<document>
%%with-pdf
<include file=cfg/references>
%%<latex>
%%\def\bibname{\small :}
%%</latex>
%%<c><p align=right><a href=@text-note-intelligent-multimedia.pdf>PDF</a></p></c>
%%<include file=announce>
:@+ intelligent multimedia @ VU
/// http://www.cs.vu.nl/~eliens/research/note-intelligent-multimedia.html
<lp>
<l>\mbox{}</l>
<br>project leader: dr A. Eliens
<br>researcher: dr. Z. Huang
<br>programmer: drs. C. Visser
<br>student: M. Hildebrand

:@- project description

We are developing a high-level platform for 3D and rich media
virtual environments
based on agent-technology, using the languages <url href=http://www.cs.vu.nl/~eliens/dlp>DLP</url>,
Java, and VRML.
On top of this platform we have developed an scripting language 
<url href=http://wasp.cs.vu.nl/step>STEP</url>
for specifying humanoid movements and gestures, based on dynamic logic.
<lp>
Our goal is to study aspects of
the deployment and architecture of virtual environments as an interface to 
i<url href=http://www.cs.vu.nl/~eliens/research>multimedia information systems</url>. 
<lp>
Our platform also supports embodied conversational agents,
see [_Platform].
As demonstrators we have developed a distributed soccer-game
prototype with intelligent autonomous avatar-embodied agents as players [_Community],
a humanoid animation demonstrating Tai-Chi, [_STEP],
avatars presenting a dialog in a mixed media presentation
environment, [_TIDSE],
a domestic agent that can be addressed in natural language, [_Interactive],
an avatar reaching for objects that uses reasoning and inverse kinematics, [_Reach],
and an avatar conductiong music, [_Conductor].
<lp>
As a student project in the
<url href=http://www.cs.vu.nl/~eliens/casus>Casus Practicum</url>,
we have developed a 3D presentation
for <url href=http://www.incca.org>INCCA</url>,
the International Network for the Conservation of Contemporary
Art, in cooperation with <url href=http://www.icn.nl>ICN</url>,
the Dutch Cultural Heritage Institute.

:@- funding
Our research has been supported by two NWO projects:
<slide color=yellow id=immed-background>
<phrase right="Both WASP~nand RIF are~nNWO projects.">
<phrase left="So what?">
<p>
<small>
<ul>
<li><url href=http://www.cs.vu.nl/~eliens/research/wasp.html>WASP</url> -- Web Agent Support Program
%%-- framework for Web Agents built on <a href=logic>DLP</a> </li>
<li><url href=http://www.cs.vu.nl/~eliens/research/rif.html>RIF</url> -- Retrieval of Information in virtual worlds using Feature detectors
%%-- information retrieval and delivery in 3D multi-user virtual environments
</ul>
</small>
\noindent
The combined effort of these projects led to the DLP+X3D
platform and the development of the STEP language. 
<lp>
In addition, we have one pending proposal with Michiel Hildebrand as candidate researcher:
<small>
<ul>
<li> (submitted) <url href=http://www.cs.vu.nl/~eliens/research/immediate.html>IMMEDIATE</url> -- Intelligent MultiMEDIA Transactions Environment

</ul>
</small>
<navigate>
</slide>


:@- cooperation
<lp>
The work on <em>embodied conversational agents</em> 
is being done in cooperation with 
dr. Z. Ruttkay from CWI.
The work on the <em>cultural heritage</em> application
is done in cooperation with drs. T. Scholte from
ICN.

:@- publications
Apart from publications in international conference proceedings 
and workshops,
we have demonstrated our work on the ICT Kenniscongres 2002
in the theme <url href=http://www.cs.vu.nl/~eliens/research/ict.html><em>intelligent multimedia</em></url>.
<lp>
In preparation is a prestigious book on <em>Life-like Characters</em>,
for which we have contributed a chapter describing our platform
and STEP, [_STEP-book].
The editor of this book, Helmut Prendinger from Tokyo University,
commented on our chapter: <em>
I really have to say that your chapter is very very well done, very
interesting, very comprehensive, and very readable. It says exactly
the
things people want to know when they are looking for some scripting
language
to animate their characters. Above that, your STEP system is very well
motivated and nicely embedded in other strands of computer science
research.  </em>.


:@- a brief history
<lp>
Although the WASP proposal was written in 1996, long
before the RIF proposal (1998), dr. Z. Huang started as a post-doc on the
WASP project when the RIF project ran already for more than
six months.
Since we then felt that the WASP project proposal was slightly
outdated, we made an effort to merge the WASP and
RIF projects, by focussing on agents in 3D virtual
environments which resulted in a paper presenting
a taxonomy of Web agents, [_Taxonomy].
However, after about a year the continuity of the RIF project
was endangered  due to a mutation of personell at <a href=http://www.cwi.nl>CWI</a>.
So, NWO was asked for permission to utilize the RIF funds
for prolonging the WASP project.
This was granted, provided that the research goals of the RIF
project were sufficiently covered within WASP.
<lp>
In the RIF project we used the <a href=http://www.blaxxun.com>blaxxun</a>
Community Server and <a href=http://www.web3d.org>VRML</a>
to realize information retrieval and delivery im multi-user 3D
environments. See [_Navigation].
Agents were then conceived as extensions on the server-side
using blaxxun's native agents enriched with embedded logic.
However, at the same time that the RIF project funds were 
transferred to WASP, the first prototype of DLP in Java
became available, and we decided, somewhat radically, to drop
the more low-level blaxxun technology in favor of a unified
approach in DLP.
Thus, we extended DLP with primitives for manipulating VRML
worlds, using the Java External Authoring Interface that is
part of VRML. The DLP+VRML framework proved
to be surprisingly effective, as testified by the following references:
<slide color=blue id=avid-surprise>
<phrase right="Look at~nwhat we~nachieved!">
<phrase left="So, why do you~nneed another~nproject?">
<c><p align=right><red>DLP+VRML</font></p></c>
<p>
<small>
<ul>
<li>architecture for agents in virtual environments -- [_Architecture]</li>
<li>intelligent avatars in 3D virtual worlds -- [_Avatars]</li>
<li>demonstrator: multi-user soccer game -- [_Community]</li>
</ul>
</small>
<navigate>
</slide>
Now, the language DLP itself has quite a long history, [_DLP].
It has also been described in [_OO].
As a language, DLP offers an object-oriented extension
of (traditional, Edinburgh-style) Prolog, with multi-threaded
objects, non-logical instance or state variables, 
communication by rendex-vous and (distributed) backtracking.
After preliminary prototypes in C++,
we focussed on an implementation in Java, to be able to use
DLP for Web programming, [_WebComputing].
The first Java implementation became available relatively late,
but just in time to create the DLP+VRML extension when needed.
<lp>
As concerns the acceptance of our approach within the Web3D
community, we wish to point to the acceptance of our [_Community] 
paper for the highly competetive international Web3D Conference
2002 (acceptance: 1 out of 13),
and the acceptance of [_STEPIMP] for the Web3D 2003 Conference.
More recently, we have made an effort to publish in the
ECA (Embodied Conversation Agents) community, as testified
by our contribution to the <em>Life-like Agents</em> book, [_STEP-book].
We also received an invitation for the Dagstuhl seminar
on <em>Evaluating Embodied Conversational Agents</em> in March 2004.


:@- embedding in education: focus on multimedia

<c><p align=right><a href=http://www.cs.vu.nl/~eliens/mm/mmc.html>focus on multimedia</a></p></c>
<lp>
The <em>intelligent multimedia</em> research has a strong  impact on the educational activities
for the specialisation(s) Multimedia with Computer Science and
Multimedia and Culture for Information Science.
<slide color=white a=0.2 id=avid-edu-focus>
<phrase right="We~nfocus on~nIntelligent Multimedia!">
<phrase left="Intelligent?~nWhat do you~nmean?">
<lp>
In the first year students
start with a general <url href=http://www.cs.vu.nl/~eliens/imm>Introduction to Multimedia</url>.
This course centers around three themes:    
the convergence between media, platforms and delivery technology,
the availability of                                           
broadband communication and its impact on the development of 
standards such as MPEG-4, and multimedia information retrieval 
as an essential ingredient of the growing multimedia information repository 
on the Web.                                       
<navigate>
</slide>
<lp>
There are two follow-up courses, which are given in respectively the 
second and third year:                                               
<slide id=avid-edu-follow>
<phrase right="DLP+VRML~nNaturally!">
<phrase left="that sounds~ncircular.~nI think.">
<c><p align=right><red>courses</font></p></c>
<p>
<small>
<ul bullet=orange>                                                                 
<li><url href=http://www.cs.vu.nl/~eliens/mma1>Multimedia Authoring I -- Web3D/VRML</url> </li>    
<li><url href=http://www.cs.vu.nl/~eliens/mma2>Multimedia Authoring II -- Virtual Environments </url> </li>                                                           
</ul>                                                                
</small>
<navigate>
</slide>
<p>                                                                  
The first of these courses deals with the technology for creating 3D scenes and 
worlds, whereas the second is                                        
more focused on providing intelligent services in virtual environments.         
Students use the DLP+VRML framework for their assignment in the second course. See [_Intelligent].
<lp>
In addition for Multimedia and Culture there is
a <url href=http://www.cs.vu.nl/~eliens/casus>Multimedia Development Casus Practicum</url> in which the technology is applied in an assignment
developed with the Dutch Cultural Heritage Institute (ICN).
<lp>
For both specialisations, Multimedia and Multimedia and Culture
we plan to offer a course on
<url href=http://www.cs.vu.nl/~eliens/mm/course-xml.html>XML-based Multimedia Technology</url>, to be developed by dr. Z. Huang, to make 
students familiar with advanced topics in XML-based
information processing. 
As a remark, our platform does already support the use of
XML and XSLT stylesheets, [_XSTEP],
and we are migrating to a DLP+X3D platform,
with <url href=http://www.web3d.org>X3D</url> 
as the XML-based successor of VRML.

:@+ research directions  

Apart from the issues involved in the modelling
and realization of embodied agents in rich media
3D environments, there are also issues 
with regard to the architecture and implementation
of our DLP+X3D platform.

:@ parallelism and synchronization
Complex humanoid gestures are of a highly parallel nature.
The STEP scripting language
supports a direct way of modelling parallel gestures
by offering a parallel construct
(<em>par</em>), which results in the simultaneous
execution of (possibly compound) actions.
To avoid unconstrained thread creation, 
the STEP engine makes use of a thread pool,
containing a fixed number of threads,
from which threads are allocated to actions.
Once the action is finished, the thread is put back in
the pool.
This approach works well for most examples.
However when many threads are needed,
as in the conductor example
(which requires approximately 60 threads),
problems may occur, in particular when there are may background jobs.
%%<lp>
%%Summarizing, as concerns the use of parallelism on modeling
%%gestures we run into a number of problems which are either
%%caused by exhausting the resources of the machine,
%%inefficiencies in the execution of Prolog code,
%%or limitations of the thread model supported by DLP.
%%Partial remedies include, respectively,
%%reducing the number of threads needed,
%%eliminating nested parallel constructs,
%%optimizing the Prolog execution engine, and a push-down
%%of critical code of the STEP engine to the Java level.
%%These measures can be taken without affecting the 
%%STEP engine or the underlying DLP thread model.

:@ modeling and representation
Our agent model may be characterized as a
BDI-model, extended with <em>sensors</em> and <em>effectors</em>
needed for the interaction in a virtual environment.
The STEP scripting language has been developed to
facilitate the specification of communicative acts,
like gestures.
However, we would also like to explore text-to-speech
synthesis as an extra modality of communication.
<lp>
One interesting research issue is how to specify
a reusable library of gestures, accomodating for differences
in (personal) style.
This is currently being investigated by Z. Ruttkay from CWI.
<lp>
Another intersting issue is the use of inverse kinematics
to grasp objects. However, when an object is not within
reach, the agent has to reason about the best way to get near
to the object, to be able to reach it.


:@ architecture and implementation
To solve the problem of reliable timing would require not
only a modification of the STEP engine,
but also a rather different implementation
of the DLP threads supporting the parallelism in STEP.
Currently, the implementation only allows for
<em>best effort</em> parallelism and does not provide
the means for <em>deadline scheduling</em>.
<lp>
However, it is our impression that we have reached
the utmost efficiency feasible within the Java
platform.
Therefore we have been considering to redevelop the
DLP+X3D platform in a <url href=http://www.microsoft.com>.NET environment</url>.
An additional advantage of migrating to the .NET environment would be 
the possible integration of  functionality such as 
<em>text-to-speech</em> synthesis which is not readily available 
in the Java environment.

%%<include file=@biblio/refs>
</document>
